//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void weircdIpsInit() {
	int r = 0;
	while (r < COMPILEOPTION_IPSTORAGESIZE) {
		ips[r] = NULL;
		r += 1;
	}
}
int addIp(const unsigned char* vIp) {
	int r = getIpID(vIp);
	if (r >= 0) {return r;}
	r = 0;
	while (r < COMPILEOPTION_IPSTORAGESIZE) {
		if (ips[r] == NULL) {
			ips[r] = malloc(sizeof(struct weircd_ipdata));
			if (ips[r] != NULL) {
				memset(ips[r],0,sizeof(struct weircd_ipdata));
				strcpy(ips[r]->ip,vIp);
				return r;
			}
		}
		r += 1;
	}
	return -1;
}
int clonesalarm(const unsigned char* vIp) {
	if (cuo.maxconnsperip <= 0) {return -1;}
	int r = getIpID(vIp);
	if (r < 0) {
		return -1;
	}
	int k = 0;
	r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] != NULL) {
			if (strcasecmp(userpointers[r]->ip,vIp) == 0) {
				k += 1;
			}
		}
		r += 1;
	}
	if (k > cuo.maxconnsperip) {
		r = 0;
		while (r < COMPILEOPTION_MAXUSERS) {
			if (userpointers[r] != NULL) {
				if (strcasecmp(userpointers[r]->ip,vIp) == 0) {
					usnd(r,"ERROR :Closing link: Clone limit reached");
					userQuit(r,USERQUIT_ERROR);
				}
			}
			r += 1;
		}
		return 1;
	}
	return -1;
}
int connectthrottled(const unsigned char* vIp) {
	int r = getIpID(vIp);
	if (r < 0) {
		r = addIp(vIp);
		if (r >= 0) {ips[r]->lastconnect2 = ts();}
		return -1;
	}
	if (ips[r]->lastconnect + 60 > ips[r]->lastconnect2 && ips[r]->lastconnect2 + 20 > ts()) {
		//ips[r]->lastconnect = ips[r]->lastconnect2;
		//ips[r]->lastconnect2 = ts();
		return 1;
	}
	ips[r]->lastconnect = ips[r]->lastconnect2;
	ips[r]->lastconnect2 = ts();
	return -1;
}
