//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void links_init() {
	int r = 0;
	while (r < MAXPASSIVELINKS) {
		plinks[r] = NULL;
		r++;
	}
	linkstcp_init();
	links_users_servclear();
}
void sendalllinks(const unsigned char* stuff) {
	int r = 0;
	int oldenv = cTcp;
	while (r < MAXPASSIVELINKS) {
		if (plinks[r] != NULL) {
			if (plinks[r]->islistener == 0) {
				int i = linkstcp_getPassiveTcp(r);
				if (i >= 0) {
					if (lt[i]->established == 1) {
						linkwrapper_environment(i);
						sendOnLink(plinks[r]->protocol,stuff);
					}
				}
			}
		}
		r++;
	}
	r = 0;
	while (r < MAXACTIVELINKS) {
		if (alinks[r] != NULL) {
			if (alinks[r]->disconnected == 0) {
				int i = linkstcp_getActiveTcp(r);
				if (i >= 0) {
					if (lt[i]->established == 1) {
						linkwrapper_environment(i);
						sendOnLink(alinks[r]->protocol,stuff);
					}
				}
			}
		}
		r++;
	}
	linkwrapper_environment(oldenv);
}
void sendontcp(const unsigned char* stuff,int tcp) {
	unsigned char* p;
	if (lt[tcp]->type == LINKTYPE_ACTIVE) {
		p = alinks[lt[tcp]->id]->protocol;
	}else{
		p = plinks[lt[tcp]->id]->protocol;
	}
	int oldenv = cTcp;
	linkwrapper_environment(tcp);
	sendOnLink(p,stuff);
	linkwrapper_environment(oldenv);
}
void sendtoservid(const unsigned char* stuff,int id) {
	int r = svtcp[id];
	
	unsigned char* p = NULL;
	if (lt[r]->type == LINKTYPE_ACTIVE) {
		p = alinks[lt[r]->id]->protocol;
	}else{
		p = plinks[lt[r]->id]->protocol;
	}
	int oldenv = cTcp;
	linkwrapper_environment(r);
	sendOnLink(p,stuff);
	linkwrapper_environment(oldenv);
}
void sendallflagged(const unsigned char* stuff) {
	int oldenv = cTcp;
	int r = 0;
	unsigned char* p = NULL;
	while (r < MAXLINKS) {
		if (linkstcp[r] != NULL) {
			if (linkstcp[r]->flagged == true && linkstcp[r]->type != LINKTYPE_LISTENER) {
				if (lt[r]->type == LINKTYPE_ACTIVE) {
					p = alinks[lt[r]->id]->protocol;
				}else{
					p = plinks[lt[r]->id]->protocol;
				}
				linkwrapper_environment(r);
				sendOnLink(p,stuff);
			}
		}
		r++;
	}
}
void sendtoservname(const unsigned char* name,const unsigned char* stuff) {
	//printf("TOSERV [%s]: %s\n",name,stuff);
	int r = links_users_servid(name);
	if (r >= 0) {sendtoservid(stuff,r);}
}
void sendalllinks_exception(const unsigned char* stuff, int exception) {
	int r = 0;
	int oldenv = cTcp;
	while (r < MAXPASSIVELINKS) {
		if (plinks[r] != NULL) {
			if (plinks[r]->islistener == 0) {
				int i = linkstcp_getPassiveTcp(r);
				if (i >= 0 && i != exception) {
					if (lt[i]->established == 1) {
						linkwrapper_environment(i);
						sendOnLink(plinks[r]->protocol,stuff);
					}
				}
			}
		}
		r++;
	}
	r = 0;
	while (r < MAXACTIVELINKS) {
		if (alinks[r] != NULL) {
			if (alinks[r]->disconnected == 0) {
				int i = linkstcp_getActiveTcp(r);
				if (i >= 0 && i != exception) {
					if (lt[i]->established == 1) {
						linkwrapper_environment(i);
						sendOnLink(plinks[r]->protocol,stuff);
					}
				}
			}
		}
		r++;
	}
	linkwrapper_environment(oldenv);
}
void telllinksaboutserver(int tcp, const unsigned char* name, const unsigned char* linkedto, int hops, const unsigned char* description) {
	printf("introduce server %s with connection %d\n",name,tcp);
	unsigned char send[500];
	if (linkedto != NULL) {
		snprintf(send,499,"addserver %s %d %s :%s",name,hops+1,linkedto,description);
	}else{
		snprintf(send,499,"addserver %s %d :%s",name,hops+1,description);
	}
	send[499] = 0;
	sendalllinks_exception(send,tcp);
}
void sendonlink(const unsigned char* stuff,int user) {
	int r = up[user]->linktcpdata;
	unsigned char* p = NULL;
	if (lt[r]->type == LINKTYPE_ACTIVE) {
		p = alinks[lt[r]->id]->protocol;
	}else{
		p = plinks[lt[r]->id]->protocol;
	}
	int oldenv = cTcp;
	linkwrapper_environment(r);
	sendOnLink(p,stuff);
	linkwrapper_environment(oldenv);
}
void activelinks_processconnect(int aid) {
	unsigned char tmp[500];
	linkwrapper_environment(alinks[aid]->tcp);
	enableLink(alinks[aid]->protocol);
}
int socket_canwrite(int socket, int timeout) {//timeout is in microseconds
	struct timeval t;
	memset(&t,0,sizeof(struct timeval));
	fd_set sset;
	FD_ZERO(&sset);
	FD_SET(socket,&sset);
	t.tv_usec = timeout;
	int r = 0;
	r = select(socket+1,NULL,&sset,NULL,&t);
	if (r < 1) {return -1;}else{return 0;}
}
void activelinks_connectfail(int r) {
	unsigned char tmp[500];
	snprintf(tmp,499,"[LINKS] Failed to actively connect to %s:%d",alinks[r]->target,alinks[r]->port);
	tmp[499] = 0;
	IOnotice(tmp);
	linkstcp_closeActive(r,1);
	alinks[r]->disconnected = 1;
	alinks[r]->disconnecttime = ts();
}
void activelinks_checkconnect() {
	int r = 0;
	while (r < MAXACTIVELINKS) {
		if (alinks[r] != NULL) {
			if (alinks[r]->disconnected != 1 && alinks[r]->socket != -1) {
				if (linkstcp[alinks[r]->tcp]->connecting == 1) {
					if (socket_canwrite(alinks[r]->socket,1000) == 0) {
						linkstcp[alinks[r]->tcp]->connecting = 2;
						if (linkstcp_vsnd("\r\n",alinks[r]->tcp) < 0) {
							activelinks_connectfail(r);
						}else{
							linkstcp[alinks[r]->tcp]->connecting = 2;
							linkstcp[alinks[r]->tcp]->connecttime = ts();
							linkstcp[alinks[r]->tcp]->somethingsent = 0;
						}
					}else{
						if (linkstcp[alinks[r]->tcp]->connecttime + 5 < ts()) {
							activelinks_connectfail(r);
						}
					}
				}else{
					if (linkstcp[alinks[r]->tcp]->connecting == 2) {
						if (linkstcp[alinks[r]->tcp]->connecttime + 2 < ts() && linkstcp[alinks[r]->tcp]->somethingsent == 0) {
							activelinks_connectfail(r);
							r++;continue;
						}
						if (linkstcp[alinks[r]->tcp]->somethingsent == 1) {
							activelinks_processconnect(r);
							linkstcp[alinks[r]->tcp]->connecting = 0;
							r++;continue;
						}
					}
				}
			}
		}
		r++;
	}
}
int newpassiveconnection(int listener, const unsigned char* ip) {
	int r = 0;
	while (r < MAXPASSIVELINKS) {
		if (plinks[r] == NULL) {
			plinks[r] = malloc(sizeof(struct weircd_passivelink));
			if (plinks[r] == NULL) {return -1;}
			memset(plinks[r],0,sizeof(struct weircd_passivelink));
			plinks[r]->password = plinks[listener]->password;
			plinks[r]->protocol = plinks[listener]->protocol;
			plinks[r]->port = plinks[listener]->port;
			int k = linkstcp_openPassive(r);
			if (k < 0) {free(plinks[r]);plinks[r] = NULL;return -1;}
			strncpy(plinks[r]->ip, ip, 16);
			plinks[r]->ip[16] = 0;
			//wlinks_msg("Establishing link to %s:%d (passive)",plinks[r]->ip, plinks[r]->port);
			return r;
		}
		r++;
	}
	return -1;
}
int newpassivelink(const unsigned char* pw,const unsigned char* protocol) {
	int r = 0;
	while (r < MAXPASSIVELINKS) {
		if (plinks[r] == NULL) {
			plinks[r] = malloc(sizeof(struct weircd_passivelink));
			if (plinks[r] == NULL) {return -1;}
			memset(plinks[r],0,sizeof(struct weircd_passivelink));
			plinks[r]->password = malloc(strlen(pw)+1);
			if (plinks[r]->password == NULL) {
				free(plinks[r]);plinks[r] = NULL;
				return -1;
			}
			strcpy(plinks[r]->password,pw);
			plinks[r]->protocol = malloc(strlen(protocol)+1);
			plinks[r]->islistener = 1;
			if (plinks[r]->protocol == NULL) {
				free(plinks[r]->password);
				free(plinks[r]);plinks[r] = NULL;
				return -1;
			}
			strcpy(plinks[r]->protocol,protocol);
			return r;
		}
		r++;
	}
	return -1;
}
int newactivelink(const unsigned char* pw,const unsigned char* protocol, const unsigned char* tg) {
	int r = 0;
	while (r < MAXACTIVELINKS) {
		if (alinks[r] == NULL) {
			alinks[r] = malloc(sizeof(struct weircd_activelink));
			if (alinks[r] == NULL) {return -1;}
			memset(alinks[r],0,sizeof(struct weircd_activelink));
			alinks[r]->password = malloc(strlen(pw)+1);
			if (alinks[r]->password == NULL) {
				free(alinks[r]);plinks[r] = NULL;
				return -1;
			}
			strcpy(alinks[r]->password,pw);
			alinks[r]->target = malloc(strlen(tg)+1);
			if (alinks[r]->target == NULL) {
				free(alinks[r]->password);free(alinks[r]);alinks[r] = NULL;
				return -1;
			}
			strcpy(alinks[r]->target,tg);
			alinks[r]->protocol = malloc(strlen(protocol)+1);
			if (alinks[r]->protocol == NULL) {
				free(alinks[r]->target);free(alinks[r]->password);free(alinks[r]);alinks[r] = NULL;
				return -1;
			}
			strcpy(alinks[r]->protocol,protocol);
			return r;
		}
		r++;
	}
	return -1;
}
void links_checkListeners(int startup) { //check the currently opened passive links to the config data
	unsigned char tmp[500];
	if (startup == 1) {
		printf("%s Initialising server links...\n",startupprefix);
	}
	//first, check if all the listeners are still wanted
	int r,k,j;
	r = 0;
	while (r < MAXPASSIVELINKS) {
		if (plinks[r] != NULL) {
			k = 0;j = -1;
			while (k < MAXLINKS) {
				if (currentoptions.links[k] != NULL) {
					if (currentoptions.links[k]->type == LINKTYPE_LISTENER && currentoptions.links[k]->port == plinks[r]->port) {
						j = k;
						break;
					}
				}
				k++;
			}
			if (j < 0) {//no match found, so this listener has to be closed
				linkstcp_closeListener(r);//notify tcp module first
				free(plinks[r]->password);
				free(plinks[r]->protocol);
				free(plinks[r]);
				plinks[r] = NULL;
			}else{
				if (strcmp(currentoptions.links[j]->password,plinks[r]->password) != 0 || strcasecmp(currentoptions.links[j]->protocol,plinks[r]->protocol) != 0) {//password or protocol changed
					if (strcmp(currentoptions.links[j]->password,plinks[r]->password) != 0) {
						free(plinks[r]->password);
						plinks[r]->password = malloc(strlen(currentoptions.links[j]->password)+1);
						if (plinks[r]->password == NULL) {
							linkstcp_closePassive(r);
							free(plinks[r]->protocol);
							free(plinks[r]);
							plinks[r] = NULL;
							return;
						}
						strcpy(plinks[r]->password,cuo.links[j]->password);
					}
					if (strcmp(currentoptions.links[j]->protocol,plinks[r]->protocol) != 0) {
						free(plinks[r]->protocol);
						plinks[r]->protocol = malloc(strlen(currentoptions.links[j]->protocol)+1);
						if (plinks[r]->protocol == NULL) {
							linkstcp_closePassive(r);
							free(plinks[r]->password);
							free(plinks[r]);
							plinks[r] = NULL;
							return;
						}
						strcpy(plinks[r]->protocol,cuo.links[j]->protocol);
					}
					linkstcp_closeListener(r);
					linkstcp_openListener(r);//reopen with new password
				}
			}
		}
		r++;
	}
	//now check all those passive config links with no real listener yet
	r = 0;
	while (r < MAXLINKS) {
		if (currentoptions.links[r] != NULL) {
			if (currentoptions.links[r]->type == LINKTYPE_LISTENER) {
				k = 0;j = -1;
				while (k < MAXPASSIVELINKS) {
					if (plinks[k] != NULL) {
						if (plinks[k]->port == currentoptions.links[r]->port && plinks[k]->islistener == 1) {j = k;break;}
					}
					k++;
				}
				if (j < 0) {
					k = newpassivelink(currentoptions.links[r]->password,currentoptions.links[r]->protocol);
					if (k < 0) {r++;continue;}
					plinks[k]->port = currentoptions.links[r]->port;
					plinks[k]->socket = -1;
					if (linkstcp_openListener(k) == 0) {
						if (startup == 1) {
							printf("%s    > Opening passive link listener on port %d\n",startupprefixsub,cuo.links[r]->port);
						}else{
							snprintf(tmp,499,"[LINKS] Opening passive link listener on port %d",cuo.links[r]->port);
							tmp[499] = 0;
							IOnotice(tmp);
						}
					}else{
						free(plinks[k]->password);
						free(plinks[k]->protocol);
						free(plinks[k]);
						plinks[k] = NULL;
						if (startup == 1) {
							printf("%s    > Failed to open listener on port %d\n",startupprefixsub,cuo.links[r]->port);
						}else{
							snprintf(tmp,499,"[LINKS] Failed to open listener on port %d",cuo.links[r]->port);
							tmp[499] = 0;
							IOnotice(tmp);
						}
					}
				}
			}
		}
		r++;
	}
}
void links_checkActive(int startup) { //check the currently opened passive links to the config data
	unsigned char tmp[500];
	if (startup == 1) {
		printf("%s Preparing active links\n",startupprefix);
	}
	//first, check if all the active links are still wanted
	int r,k,j;
	r = 0;
	while (r < MAXACTIVELINKS) {
		if (alinks[r] != NULL) {
			k = 0;j = -1;
			while (k < MAXLINKS) {
				if (currentoptions.links[k] != NULL) {
					if (currentoptions.links[k]->type == LINKTYPE_ACTIVE && currentoptions.links[k]->port == alinks[r]->port) {
						if (strcasecmp(currentoptions.links[k]->target,alinks[r]->target) == 0) {
							j = k;
							break;
						}
					}
				}
				k++;
			}
			if (j < 0) {//no match found, so this listener has to be closed
				linkstcp_closeActive(r,0);//notify tcp module first
				free(alinks[r]->password);
				free(alinks[r]->target);
				free(alinks[r]->protocol);
				free(alinks[r]);
				alinks[r] = NULL;
			}else{
				if (strcmp(currentoptions.links[j]->password,alinks[r]->password) != 0 || strcmp(currentoptions.links[j]->protocol,alinks[r]->protocol) != 0) {//password or protocol changed
					if (strcmp(currentoptions.links[j]->password,alinks[r]->password) != 0) {
						free(alinks[r]->password);
						alinks[r]->password = malloc(strlen(currentoptions.links[j]->password)+1);
						if (alinks[r]->password == NULL) {
							linkstcp_closeActive(r,0);
							free(alinks[r]->target);
							free(alinks[r]->protocol);
							free(alinks[r]);
							alinks[r] = NULL;
							return;
						}
						strcpy(alinks[r]->password,cuo.links[j]->password);
					}
					if (strcmp(currentoptions.links[j]->protocol,alinks[r]->protocol) != 0) {
						free(alinks[r]->protocol);
						alinks[r]->protocol = malloc(strlen(currentoptions.links[j]->protocol)+1);
						if (alinks[r]->protocol == NULL) {
							linkstcp_closeActive(r,0);
							free(alinks[r]->target);
							free(alinks[r]->password);
							free(alinks[r]);
							alinks[r] = NULL;
							return;
						}
						strcpy(alinks[r]->protocol,cuo.links[j]->protocol);
					}
					linkstcp_closeActive(r,0);
					linkstcp_startActive(r);//reopen with new password
				}
			}
		}
		r++;
	}
	//now check all those active config links with no real counterpart
	r = 0;
	while (r < MAXLINKS) {
		if (currentoptions.links[r] != NULL) {
			if (currentoptions.links[r]->type == LINKTYPE_ACTIVE) {
				k = 0;j = -1;
				while (k < MAXACTIVELINKS) {
					if (alinks[k] != NULL) {
						if (alinks[k]->port == currentoptions.links[r]->port) {
							if (strcasecmp(alinks[k]->target,cuo.links[r]->target) == 0) {
								j = k;break;
							}
						}
					}
					k++;
				}
				if (j < 0) {
					k = newactivelink(currentoptions.links[r]->password,currentoptions.links[r]->protocol,currentoptions.links[r]->target);
					if (k < 0) {r++;continue;}
					alinks[k]->port = currentoptions.links[r]->port;
					alinks[k]->socket = -1;
					if (linkstcp_startActive(k) == 0) {
						if (startup == 1) {
							printf("%s    > Opening connection to %s:%d\n",startupprefixsub,cuo.links[r]->target,cuo.links[r]->port);
						}else{
							snprintf(tmp,499,"[LINKS] Opening connection to %s:%d",cuo.links[r]->target,cuo.links[r]->port);
							tmp[499] = 0;
							IOnotice(tmp);
						}
					}else{
						alinks[k]->disconnected = 1;
						alinks[k]->disconnecttime = ts();
						if (startup == 1) {
							printf("%s    > Failed to resolve %s\n",startupprefixsub,cuo.links[r]->target);
						}else{
							snprintf(tmp,499,"[LINKS] Failed to resolve %s",cuo.links[r]->target);
							tmp[499] = 0;
							IOnotice(tmp);
						}
					}
				}
			}
		}
		r++;
	}
}
void weircdLinksInit() {
	links_init();
	links_checkListeners(1);
	links_checkActive(1);
}
int protocolexists(const unsigned char* prt) {
	linkwrapper_environment(-1);
	if (enableLink(prt) != 0) {return -1;}
	return 0;
}

long lastsec = 0;
void linksProceed() {
	unsigned char tmp[500];
	if (lastsec < ts()) {
		lastsec = ts();
		activelinks_checkconnect();
	}
	int r = 0;
	while (r < MAXACTIVELINKS) {
		if (alinks[r] != NULL) {
			if (alinks[r]->disconnected == 1 && alinks[r]->disconnecttime  + COMPILEOPTION_LINKRECONNECTTIME < ts()) {
				if (linkstcp_startActive(r) == 0) {
					snprintf(tmp,499,"[LINKS] Opening connection to %s:%d",alinks[r]->target,alinks[r]->port);
					tmp[499] = 0;
					IOnotice(tmp);
					alinks[r]->disconnected = 0;
				}else{
					alinks[r]->disconnected = 1;
					alinks[r]->disconnecttime = ts();
					snprintf(tmp,499,"[LINKS] Failed to resolve %s",alinks[r]->target);
					tmp[499] = 0;
					IOnotice(tmp);
				}
			}
		}
		r++;
	}
	r = 0;//THROW OUT PASSIVE LINKS WHICH DO NOTHING
	while (r < MAXPASSIVELINKS) {
		if (plinks[r] != NULL) {
			int j = linkstcp_getPassiveTcp(r);
			if (j >= 0) {
				if (lt[j]->established == 0 && plinks[r]->connecttime + 10 < ts()) {
					linkstcp[j]->needquit = 1;
				}
			}
		}
		r++;
	}
	linktcp_checktimeout();
	linktcp_check();
	r = 0;
	while (r < MAXLINKS) {
		if (linkstcp[r] != NULL) {
			if (linkstcp[r]->needquit == 1) {
				int i = linkstcp[r]->id;
				if (linkstcp[r]->type == LINKTYPE_PASSIVE) {
					linkstcp_closePassive(i);
					free(plinks[i]);
					plinks[i] = NULL;
				}else{
					linkstcp_closeActive(i,0);
					alinks[i]->disconnected = 1;
					alinks[i]->disconnecttime = ts();
				}
			}else{
				if (linkstcp[r]->type != LINKTYPE_LISTENER) {
					linkstcp_doReceive(r);
				}
			}
		}
		r++;
	}
	linkstcp_sendAll();
}

