//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void weircdUserInit() {
	int r = 0;
	while (r < userslotcount) {
		userpointers[r] = NULL;
		r += 1;
	}
}
int userAdd(int socket) {
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] == NULL) {
			userpointers[r] = malloc(sizeof(struct weircd_user));
			memset(userpointers[r], 0, sizeof(struct weircd_user));
			userpointers[r]->socket = socket;
			userpointers[r]->authed = false;
			userpointers[r]->sendbeforeremove = false;
			userpointers[r]->ircop = false;
			userpointers[r]->quitreason = NULL;
			userpointers[r]->hopcount = 0;
			if (r >= userslotcount) {userslotcount = r+1;}
			FD_SET(socket,&socketset);//add this socket to our select()-file descriptor set
			recalculatenfds();
			return r;
		}
		r += 1;
	}
	close(socket);//adding failed!
	return -1;
}
unsigned char* un(int uid) {
	if (userpointers[uid] != NULL) {
		return userpointers[uid]->nickname;
	}else{
		return NULL;
	}
}
int ubn(const unsigned char* nickname) {//UserByName()
	int r = 0;
	while (r < userslotcount) {
		if (userpointers[r] != NULL) {
			if (strcasecmp(userpointers[r]->nickname,nickname) == 0 && userpointers[r]->pleaseremove == false) {
				return r;
			}
		}
		r += 1;
	}
	return -1;
}
int uSocket(int uid) {
	return userpointers[uid]->socket;
}
bool isuserinchan(int userid, int vchanid) {
	if (userpointers[userid] == NULL) {return false;}
	if (userpointers[userid]->pleaseremove == true) {return false;}
	if (userpointers[userid]->authed == false) {return false;}
	int r = 0;
	while (r < COMPILEOPTION_MAXCHANSPERUSER) {
		if (userpointers[userid]->chan[r] != NULL) {
			if (userpointers[userid]->chan[r]->chanid == vchanid) {
				return true;
			}
		}
		r += 1;
	}
	return false;
}
int chanusercount(int vchanid) {
	int r = 0;int k = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (isuserinchan(r,vchanid) == true) {k += 1;}
		r += 1;
	}
	return k;
}
void netsplitchan(int id) {
	unsigned char send[500];
	//move channel to me
	chans[id]->hopcount = 0;
	chans[id]->servname = NULL;
	snprintf(send,499,"resyncchan :%s",chans[id]->name);send[499] = 0;
	sendalllinks(send);
}
void removeemptychans() {
	unsigned char send[500];
	int r = 0;
	while (r < COMPILEOPTION_MAXCHANS) {
		if (chans[r] != NULL) {
			if (chanusercount(r) <= 0) {
				snprintf(send,499,"delchannel %s",chans[r]->name);send[499] = 0;
				sendalllinks(send);
				free(chans[r]);
				chans[r] = NULL;
			}
		}
		r += 1;
	}
}
bool isProtected(int uid,const unsigned char* channame) {
	int r = getChanID(channame);
#ifdef SERVICES_ENABLED
	unsigned char *co;
	if (cuo.services_activated == 1) {
		if (chanregistered(channame) == true) {
			co = services_chanowner(channame);
			if (userpointers[uid]->accountname == NULL || co == NULL) {return false;}
			if (strcasecmp(userpointers[uid]->accountname,co) == 0) {
				free(co);
				return true;
			}
			free(co);
			return false;
		}
	}
#endif
	return false;
}
bool isOppedOnJoin(int uid,const unsigned char* channame) {
	int r = getChanID(channame);
#ifdef SERVICES_ENABLED
	unsigned char *co;
	if (cuo.services_activated == 1) {
		if (chanregistered(channame) == true) {
			if (userpointers[uid]->accountname != NULL) {
				if (strcasecmp(userpointers[uid]->accountname,"") != 0) {
					int k = chanserv_autoop(channame,userpointers[uid]->accountname);
					if (k == 1) {return true;}
					if (k < 0) {printf("Database problem (ChanServ auto op)\n");}
				}
			}
			return false;
		}
	}
#endif
	if (r >= 0) {return false;}
	return true;
}
void tellaffectedusers(const unsigned char* stuff, int senderid) {
	int k = 0;
	int r;
	while (k < userslotcount) {
		useraffected[k] = false;
		k += 1;
	}
	k=0;
	while (k < COMPILEOPTION_MAXCHANSPERUSER) {
		if (userpointers[senderid]->chan[k] != NULL) {
			r = 0;
			while (r < userslotcount) {
				if (userpointers[r] != NULL && r != senderid) {
					if (userpointers[r]->pleaseremove == false) {
						if (isuserinchan(r,userpointers[senderid]->chan[k]->chanid) == true) {
							useraffected[r] = true;
						}
					}
				}
				r += 1;
			}
		}
		k += 1;
	}
	k=0;
	while (k < userslotcount) {
		if (useraffected[k] == true) {
			usnd(k,stuff);
		}
		k += 1;
	}
}
void userQuit(int uid, int reason) {
	//if (userpointers[uid] == NULL) {printf("ERROR!!!!!!!!!!!(%d)\n",uid);return;}
	unsigned char response[501];
	if (userpointers[uid]->pleaseremove == false) {
		snprintf(&response[0],499,":%s!%s@%s QUIT :",userpointers[uid]->nickname,userpointers[uid]->suserid,userpointers[uid]->host);
		response[499] = 0;
		if (reason == USERQUIT_QUIT) {
			strncat(response,"Quit: ",499);
			response[499] = 0;
			if (userpointers[uid]->quitreason != NULL) {
				strncat(response,userpointers[uid]->quitreason,499);
				response[499] = 0;
				free(userpointers[uid]->quitreason);
				userpointers[uid]->quitreason = NULL;
			}
		}
		if (reason == USERQUIT_LINKCLOSE) {
			strncat(response,"Port is closing down",499);
			response[499] = 0;
		}
		if (reason == USERQUIT_TIMEOUT) {
			strncat(response,"Ping timeout",499);
			response[499] = 0;
		}
		if (reason == USERQUIT_EOF) {
			strncat(response,"Client quit",499);
			response[499] = 0;
		}
		if (reason == USERQUIT_EXCESSFLOOD) {
			strncat(response,"Excess flood",499);
			response[499] = 0;
		}
		if (reason == USERQUIT_SENDQEXCEEDED) {
			strncat(response,"SendQ exceeded",499);
			response[499] = 0;
		}
		if (reason == USERQUIT_NETSPLIT) {
			strncat(response,"Network split",499);
			response[499] = 0;
		}
		if (reason == USERQUIT_COLLISION) {
			strncat(response,"Nick collision",499);
			response[499] = 0;
			usnd(uid,"ERROR :Nick collision");
		}
		if (reason == USERQUIT_ERROR) {
			if (userpointers[uid]->quitreason != NULL) {
				strncat(response,userpointers[uid]->quitreason,499);
				response[499] = 0;
				free(userpointers[uid]->quitreason);
				userpointers[uid]->quitreason = NULL;
			}
		}
		if (reason != USERQUIT_COLLISION || userpointers[uid]->hopcount <= 0) {
			tellaffectedusers(response,uid);
		}
		if (reason != USERQUIT_COLLISION) {
			if (userpointers[uid]->hopcount <= 0) {
				sendalllinks(response);
			}else{
				sendalllinks_exception(response,userpointers[uid]->linktcpdata);
			}
		}
	}
	if (reason != USERQUIT_ERROR && reason != USERQUIT_TIMEOUT && reason != USERQUIT_SENDQEXCEEDED && reason != USERQUIT_EXCESSFLOOD && reason != USERQUIT_REGISTERTIMEOUT && reason != USERQUIT_COLLISION) {
		userpointers[uid]->pleaseremove = true;
		userpointers[uid]->sendbeforeremove = false;
		removeemptychans();
	}else{
		if (userpointers[uid]->pleaseremove == true) {return;}
		userpointers[uid]->pleaseremove = true;
		userpointers[uid]->pleaseremove_time = ts();
		userpointers[uid]->sendbeforeremove = true;
		removeemptychans();
	}
}
double cseed (int seed) {
	return seed * (1.0/(RAND_MAX + 1.0));
}
int vrandom(int start, int end) {
	return start + cseed(rand()) * (end - start);
}
void forcerename(int uid) {
	unsigned char nnick[50];
	unsigned long long k = ts()-vrandom(-5,50);srand(ts());
	while (1) {
		sprintf(&nnick[0],"Guest%ld",k);
		if (ubn(nnick) < 0) {break;}
		k += vrandom(2,7);
	}
	unsigned char msg[500];
	snprintf(&msg[0],500,":%s!%s@%s NICK %s",userpointers[uid]->nickname,userpointers[uid]->suserid,userpointers[uid]->host,nnick);
	msg[499] = 0;
	tellaffectedusers(msg,uid);
	usnd(uid,msg);
	strcpy(userpointers[uid]->nickname,nnick);
	userpointers[uid]->lastnickchange = ts();
	userpointers[uid]->needstimeout = 0;
	int gip = getIpID(userpointers[uid]->ip);
	if (gip >= 0) {ips[gip]->nicklock = ts()+20;}
}
void clearusers() {
	unsigned char snd[300];
	int r = 0;
	while (r < userslotcount) {
		if (userpointers[r] != NULL) {
			if (userpointers[r]->pleaseremove == true) {
				if (userpointers[r]->sendbeforeremove == false || userpointers[r]->pleaseremove_time + 2 < ts() || userpointers[r]->sendbuffer[0] == NULL) {
					if (userpointers[r]->hopcount <= 0) {
						if (userpointers[r]->socketunselected == 0) {
							userpointers[r]->socketunselected = 1;
							FD_CLR(userpointers[r]->socket,&socketset);
							nfds--;
						}
						close(userpointers[r]->socket);
					}
					if (userpointers[r]->quitreason != NULL) {
						free(userpointers[r]->quitreason);
						userpointers[r]->quitreason = NULL;
					}
#ifdef SERVICES_ENABLED
					if (userpointers[r]->accountname != NULL) {
						free(userpointers[r]->accountname);
						userpointers[r]->accountname = NULL;
					}
#endif
					int j = 0;
					while (j < COMPILEOPTION_MAXCHANSPERUSER) {
						if (userpointers[r]->chan[j] != NULL) {free(userpointers[r]->chan[j]);}
						j++;
					}
					wantsend -= userpointers[r]->sendblocks;
					free(userpointers[r]);
					userpointers[r] = NULL;
				}
			}else{
				if (userpointers[r]->authed == true) {
					if (userpointers[r]->hopcount <= 0) {
						if (userpointers[r]->ping_waitingforpong <= 0) {
							if (userpointers[r]->ping_lastping + COMPILEOPTION_PINGFREQUENCY < ts() && userpointers[r]->hopcount <= 0) {
								userpointers[r]->ping_pingval = ts();
								sprintf(&snd[0],"PING :%ld",userpointers[r]->ping_pingval);
								usnd(r,snd);
								userpointers[r]->ping_waitingforpong = ts();
							}
						}else{
							if (userpointers[r]->ping_waitingforpong + 40 < ts()) {
								usnd(r,"ERROR :Closing link: ping timeout");
								userQuit(r,USERQUIT_TIMEOUT);
							}
						}
					}
				}else{
					if (userpointers[r]->CONNECTtime + 15 < ts()) {
						usnd(r,"ERROR :Closing link: Registration timeout");
						userQuit(r,USERQUIT_REGISTERTIMEOUT);
					}
				}
#ifdef SERVICES_ENABLED
				if (cuo.services_activated == 1) {
					if (SERVICES_LOGINTIMEOUT > 0 && userpointers[r]->needstimeout == 1) {
						if (userpointers[r]->lastnickchange + SERVICES_LOGINTIMEOUT <= ts()) {forcerename(r);}
					}
				}
#endif
			}
		}
		r += 1;
	}
}
void tellallusersinchan(const unsigned char* stuff,int chanid) {
	int r = 0;
	while (r < userslotcount) {
		if (isuserinchan(r,chanid) == true) {
			usnd(r,stuff);
		}
		r += 1;
	}
}
void tellallusersinchan_local(const unsigned char* stuff,int chanid) {
	int r = 0;
	while (r < userslotcount) {
		if (up[r] != NULL) {
			if (isuserinchan(r,chanid) == true && up[r]->hopcount <= 0) {
				usnd(r,stuff);
			}
		}
		r += 1;
	}
}
void tellallusersinchan_exclude(const unsigned char* stuff,int chanid,int excludeid) {
	int r = 0;
	while (r < userslotcount) {
		if (isuserinchan(r,chanid) == true && r != excludeid) {
			usnd(r,stuff);
		}
		r += 1;
	}
}
void tellallusersinchan_localexclude(const unsigned char* stuff,int chanid,int excludeid) {
	int r = 0;
	while (r < userslotcount) {
		if (up[r] != NULL && r != excludeid) {
			if (isuserinchan(r,chanid) == true && up[r]->hopcount <= 0) {
				usnd(r,stuff);
			}
		}
		r += 1;
	}
}
unsigned char userprefix(int userid, int vchanid) {
	if (userpointers[userid] == NULL) {return 0;}
	if (userpointers[userid]->pleaseremove == true) {return 0;}
	if (userpointers[userid]->authed == false) {return 0;}
	if (isuserinchan(userid,vchanid) == false) {return 0;}
	int r = 0;
	while (r < COMPILEOPTION_MAXCHANSPERUSER) {
		if (userpointers[userid]->chan[r] != NULL) {
			if (userpointers[userid]->chan[r]->chanid == vchanid) {
				struct weircd_user_chaninfo* ch = userpointers[userid]->chan[r];
				if (ch->iamop == true) {
					return '@';
				}else{
					if (ch->iamhalfop == true) {
						return '%';
					}else{
						if (ch->iamvoice == true) {
							return '+';
						}else{
							return 0;
						}
					}
				}
			}
		}
		r += 1;
	}
	return 0;
}
void IOnotice(const unsigned char* str) {
	unsigned char stuff[500];
	int r = 0;
	while (r < userslotcount) {
		if (userpointers[r] != NULL) {
			if (userpointers[r]->pleaseremove == false && userpointers[r]->ircop == true) {
				snprintf(&stuff[0],499,":%s NOTICE %s :%s",cuo.svd,un(r),str);
				stuff[499] = 0;
				usnd(r,stuff);
			}
		}
		r += 1;
	}
}
